class Bomb{
  float type;
  float x, y, velox, veloy; // Variables for velo and position for creation of the Vector
  PVector position, velocity; //Vectors for the velocity and positions of the bomb
  color colorbomb; // defines the color of the bomb
  int typecolor, typeplatform; // indicate the type of the bomb and the platform it belongs to;
  float radius, m;
  PImage[] img = new PImage[2]; // Variable storing the image of display;
  float limitx1, limitx2, limity1, limity2, upperlimit; //limits for position of the bomb
  int correctplat, actualplat;
  int condition = 1;
  float plat1x, plat2x, platy, platwidth , platheight;  // Dimensions of platforms
  float tempvelox, tempveloy; // Temporary variables to store velocity when the bomb is dragged
  boolean inplat = false; //Check if the bomb is inside a platform
  boolean releasedbymouse = false; // Check if bomb is released by mouse
  int platformnum; // Variable checking for the platform number placed in
  int draggedbomb = 0;
  boolean controlledbymouse = false;
  boolean gameover = false;
  int timeonscreen = 0; //Variable storing the time the bomb has been on the screen and is not placed in platform
  int scoreyes = 1;
  
  Bomb(){
    img[0] = loadImage("img1.PNG");
    img[1] = loadImage("img0.PNG");
    img[1].resize(60,60);
    img[0].resize(70,60);
    platformnum = 0;
    condition = 1;
    x = width/2;
    y = 40;
    velox = 0;
    veloy = random(1, 3);
    typecolor = (int)random(1, 3);
    typeplatform = typecolor;
    correctplat = typecolor;
    position = new PVector(x, y);
    velocity = new PVector(velox, veloy);
    radius = 40;
    plat1x = 0;
    plat2x = 600;
    platy = 150;
    platwidth = 300;
    platheight = 300;
    limitx1 = 300;
    limitx2 = width - 300;
    limity1 = 150;
    limity2 = height - 150;
    upperlimit = 0;
    if(typecolor ==1){
      colorbomb = color(98, 0, 246);
    }
    else if(typecolor == 2){
      colorbomb = color(255);
    }
  }
  
  
  //=========================================================
  void move(){
    
    position.add(velocity);
    
    if( position.x > width - radius/2 ) 
    {
     position.x = width - radius/2;
     velocity.x *= -1;
    }
    else if (position.x < radius/2)
    {
     position.x = radius/2;
     velocity.x *= -1;
    }
    else if (position.y > height - radius/2)
    {
     position.y = height - radius/2;
     velocity.y *= -1; 
    }
    else if (position.y < upperlimit + radius/2 )
    {
     position.y = upperlimit + radius/2;
     velocity.y *= -1;
    }
     
     
  }
  //=========================================================
  //Function used to keep track of time each bomb is on screen
  void updatetimeonscreen(){
    if(inplat == false){
      if(frameCount % 100 == 0){
        timeonscreen++;
      }
    }  
  }
  
  //=========================================================
  //Function to determine whether bomb should explode and game over should be called
  void explode(){
    //TO fill
    if(actualplat != 0){ // Determines whether a bomb is in the wrong platform
      if(actualplat != correctplat){
        gameover = true;
      }
    }
    else if(timeonscreen == 20){ //Determines whether a bomb has been for too long on screen
      gameover = true;
    }
  }
   
  void updatetint(){
    
    
  }
  //=========================================================
  //Function to detect collisions and change direction if collision is made
  void collision(Bomb b){
    //TO fill
    
    if(dist(position.x, position.y, b.position.x, b.position.y) < radius){
      velocity.x *= -1;
      velocity.y *= -1;
      b.velocity.y *= -1;
      b.velocity.x *= -1;
    }
  }
  
  //=========================================================
  //Function to determine whether bomb collides with a platform
  void collisionwithplatform()
  {
    
   if( ((position.x + radius + velocity.x > plat1x &&
   position.x - radius/2 + velocity.x < plat1x + platwidth) ||
   (position.x + radius/2 + velocity.x > plat2x &&
   position.x + velocity.x < plat2x + platwidth)) &&
   position.y + radius/2 > platy &&
   position.y - radius/2 < platy + platheight)
   {
     velocity.x *= -1;
   }
   
   if( ((position.x + radius/2 > plat1x &&
   position.x - radius/2 < plat1x + platwidth) ||
   (position.x + radius/2 > plat2x &&
   position.x < plat2x + platwidth)) &&
   position.y + radius/2 + velocity.y > platy &&
   position.y - radius/2 + velocity.y < platy + platheight){
   
     velocity.y *= -1;
   }
  }
  
  //=========================================================
  //Function indicating mouse released after mouse grabs bomb
  void release(){
    velocity.x = (random(0, 4)-2);
    tempvelox = velocity.x;
    tempveloy = velocity.y;
  }
  
  //=========================================================
  //Function setting the upperlimit after bomb is initially released
  void upperlimsetter(){
    upperlimit = 60;
  }
  
  //=========================================================
  //Function ton 
  void checkinplat(){
   if(position.x > radius &&
   position.x < limitx1 &&
   position.y > limity1 &&
   position.y < limity2){
     platformnum = 1;
     condition = 2;
     inplat = true;
     draggedbomb = 0;
     actualplat = 2;
     
   }
   else if(position.x > limitx2 &&
   position.x < width &&
   position.y > limity1 &&
   position.y < limity2){
     platformnum = 2;
     condition = 2;
     inplat = true;
     draggedbomb = 0;
     actualplat = 1;
   }   
  }
  
  //=========================================================
  void movementaftermouse(){
    if(releasedbymouse == true){ 
    velocity.x = tempvelox;
    velocity.y = tempveloy;
    releasedbymouse = false;
    draggedbomb = 0;
    controlledbymouse = false;
    }
  }
  
  //=========================================================
  void movementinplatform(){
    switch(platformnum){
      
      case 1:
        if( position.x > 300 - radius/2 ) 
        {
         position.x = 300 - radius/2;
         velocity.x *= -1;
        }
        else if (position.x < radius/2)
        {
         position.x = radius/2;
         velocity.x *= -1;
        }
        else if (position.y > limity2 - radius/2)
        {
         position.y = limity2 - radius/2;
         velocity.y *= -1; 
        }
        else if (position.y < limity1 + radius/2 )
        {
         position.y = limity1 + radius/2;
         velocity.y *= -1;
        }
        break;
        
      case 2:if( position.x > width - radius/2 ) 
        {
         position.x = width - radius/2;
         velocity.x *= -1;
        }
        else if (position.x < 600 + radius/2)
        {
         position.x = 600 + radius/2;
         velocity.x *= -1;
        }
        else if (position.y > limity2 - radius/2)
        {
         position.y = limity2 - radius/2;
         velocity.y *= -1; 
        }
        else if (position.y < limity1 + radius/2 )
        {
         position.y = limity1 + radius/2;
         velocity.y *= -1;
        }
        break;
    }
      
  }
  //=========================================================
  void updatescore(){
   if(inplat == true && scoreyes == 1){
     game.score++;
     scoreyes = 0;
     
   } 
  }
  
  //=========================================================
  void drawbomb(){
    if(controlledbymouse == true){
      position.x = mouseX;
      position.y = mouseY;
    }
    updatetimeonscreen();
    // Drawing the circles
    imageMode(CENTER);
    image(img[typecolor-1], position.x, position.y);
    move();
    explode();
    checkinplat();
    updatescore();
    if(position.y > 50 && position.y< 54){
       release();
    }
    if(position.y > 65){
      upperlimsetter();
    }
    switch(condition){
      case 1:
        collisionwithplatform();
        break;
      case 2:
        movementinplatform();
        break;
    }
    if(gameover == true){
      game.gameover = true;
    }
  }
 
      
    
}
