class Game{
  Bomb bombarray[]; // Array storing the number of bombs
  int i; // Variable that counts the number of bombs created
  int velobombs; //Variable determining the velocity of creation of bombs
  int score = 0; //Variable containing the score of the game
  PImage[] background = new PImage[3]; // Array storing the images for backgrounds
  PImage buttons[];// Array storing images for buttons
  int condition; //Variable containing the 
  int backgroundimg;
  int casenum; //Case number for screen function.
  String scoretext;
  boolean gameover; // Variable to determine game over
  boolean gamewin; //Variable to determine game win
  int backgroundnum; // Background image index from array
  boolean restart = false; // variable to verify if restart of the game is allowed or not
  
  Game(){
    bombarray = new Bomb[100];
    i = 0;
    velobombs = 200;
    condition = 0;
    background[2] = loadImage("background2.png");
    background[1] = loadImage("background1.png");
    background[0] = loadImage("background0.png");
    casenum = 0;
  }

  //=========================================================
  //Function to create new bombs
  void createbomb(){
    bombarray[i] = new Bomb();
    i++;
  }
  
  //=========================================================
  //Function to check release of bombs if mouse is released
  void checkrelease(){
    for(int j=0; j < i; j++){
       if(bombarray[j].controlledbymouse == true){
         bombarray[j].controlledbymouse = false;
         bombarray[j].release();
         break;
       }
    }
  }
  
  //=========================================================
  //Function checking for bomb collision
  void checkcollisions(){
   for(int j=0; j < i; j++){
     for(int k=j+1; k < i; k++){
       bombarray[j].collision(bombarray[k]);
     }
   }
  }
  
  //=========================================================
  //Function to control the bomb if grabbed
  void controlbomb(){
    for(int j=0; j<i; j++){
      if(bombarray[j].controlledbymouse == true){
        break;
      }
      else if(bombarray[j].inplat == false){
        if(dist(mouseX, mouseY, bombarray[j].position.x, bombarray[j].position.y) < bombarray[j].radius/2){
           bombarray[j].controlledbymouse = true;
           break;
            }
         }
      }
  }  
  
  //=========================================================
  //Function to draw the Game
  void drawGame(){
    if(backgroundnum < 3){
      background(background[backgroundnum]);
    }
    
    if( i >= 89){
      gamewin = true;
    }
    
    //Controlling bombs
    if(mousePressed ){
      controlbomb();
    }
    
    //Screen with actual gameplay
    //Having bomb releases
    if(backgroundnum == 1){
      if(frameCount%(velobombs) == 0 && i <= 89 && gameover == false){
        createbomb();
      }
      
      //Make the release of bombs faster
      if(frameCount%1000 == 0){
       velobombs -= 10; 
      }
      
      for(int j=0; j < i; j++){
        bombarray[j].drawbomb(); 
      }
      //printing the score
      textSize(32);
      fill(0);
      text("Score: ", 50, 585);
      text(score, 150, 585);
      
      if(score >= 80){
        backgroundnum = 4;
      }
      
      if(gameover == true){
        backgroundnum = 3;
      }
    }
    
    // First Screen
    if( backgroundnum == 0 ){
      if(mouseX > 350 && mouseX < 550 && mouseY > 380 && mouseY < 430){
        noFill();
        stroke(255, 255, 0);
        rect(350, 380, 200, 50); //SHAPE REQUIREMENT
        if(mousePressed){
          backgroundnum = 1;
        }
      }
      else if(mouseX >350 && mouseX < 550 && mouseY >460 && mouseY < 510){
        noFill();
        stroke(255, 255, 0);
        rect(350, 460, 200, 50);
        if(mousePressed){
          backgroundnum = 2;
        }
      }
    }
      
    //Screen with Instructions
    if( backgroundnum == 2 ){
      if(mouseX > 700 && mouseX < 840 && mouseY > 480 && mouseY < 530 ){
        noFill();
        stroke(255, 255, 0);
        rect(700, 480, 140, 50);
        if(mousePressed){
          backgroundnum = 1;
        }
      }
    }
      
    //Screen with losing message
    if( backgroundnum == 3 ){
      background(51);
      textSize(48);
      fill(255);
      text("Game Over!", 340, 150);
      text("Press any key to restart the game", 70, 250); 
      restart = true;
    }
    
    //Screen with winning message
    if( backgroundnum == 4 ){
      background(255, 204, 0);
      textSize(48);
      text("You won the game", 260, 200);
      text("Press any key to restart the game", 80, 250);
      restart = true;
    }
    
    if(restart == true){
      if(keyPressed){
        setup();
        sound.stop();
      }
    }
  }
  
}
